from setupdevhelpers import *
import xml.etree.ElementTree as ET
import json
import glob



def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    wget("https://demo.cyberwatch.fr/repos/mac/cyberwatch-agent.pkg","cyberwatch-agent.pkg",proxies=proxies)

    version = get_version_cyb("cyberwatch-agent.pkg")


    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    control.set_software_version(version)
    control.save_control_to_wapt()

    return result
    
def get_version_cyb(pkg_path):
    '''
    Get the properties of a .pkg file by getting the Info.plist of the package

    Args:
        pkg_path: path to .pkg file
        app_name: name of the app contained in the .pkg file

    Returns:
        plist_read: dict of Info.plist file
    '''

    # Extracting .pkg file
    run(rf"pkgutil --expand-full {pkg_path} extracted_pkg/")

    with open(r"extracted_pkg/Distribution") as f :
        data = f.read()

    tree = ET.ElementTree(ET.fromstring(data))
    root = tree.getroot()
    g = root.findall('pkg-ref')[0]
    version = g.attrib['version']

    remove_tree("extracted_pkg/")

    return version
